Summary:	Management tools for Virtual Data Optimizer
Summary(pl.UTF-8):	Narzędzia do zarządzania podsystemem Virtual Data Optimizer
Name:		vdo
# keep 6.x for now for libblockdev compatibility (`vdo` utility); 8.x is prepared on DEVEL-8 branch
Version:	6.2.11.5
Release:	1
License:	GPL v2
Group:		Applications/System
#Source0Download: https://github.com/dm-vdo/vdo/releases
Source0:	https://github.com/dm-vdo/vdo/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	3ef212c34e6103d270735111b06aa5ff
Patch0:		%{name}-x86.patch
Patch1:		%{name}-types.patch
URL:		http://github.com/dm-vdo/vdo
BuildRequires:	device-mapper-devel
BuildRequires:	libblkid-devel
BuildRequires:	libuuid-devel >= 2.23
BuildRequires:	python3 >= 1:3.6
BuildRequires:	python3-devel >= 1:3.6
BuildRequires:	python3-modules >= 1:3.6
BuildRequires:	rpm-build >= 4.6
BuildRequires:	sed >= 4.0
BuildRequires:	valgrind
BuildRequires:	zlib-devel
Requires:	libuuid >= 2.23
Requires:	lvm2
Requires:	python3 >= 1:3.6
Requires:	python3-PyYAML >= 3.10
#Suggests:	kernel-kvdo >= 6.2
ExclusiveArch:	%{ix86} %{x8664} x32 aarch64 ppc ppc64 s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Virtual Data Optimizer (VDO) is a device mapper target that delivers
block-level deduplication, compression, and thin provisioning.

This package provides the user-space management tools for VDO.

%description -l pl.UTF-8
Virtual Data Optimizer (VDO) to cel device mappera zapewniający
deduplikację, kompresję i "thin provisioning" na poziomie bloków.

Ten pakiet zawiera narzędzia przestrzeni użytkownika do zarządzania
VDO.

%package -n bash-completion-vdo
Summary:	Bash completion for VDO management commands
Summary(pl.UTF-8):	Bashowe uzupełnianie parametrów poleceń do zarządzania VDO
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion
BuildArch:	noarch

%description -n bash-completion-vdo
Bash completion for VDO management commands.

%description -n bash-completion-vdo -l pl.UTF-8
Bashowe uzupełnianie parametrów poleceń do zarządzania VDO.

%package support
Summary:	Support tools for Virtual Data Optimizer
Summary(pl.UTF-8):	Narzędzia wspomagające dla podsystemu Virtual Data Optimizer
Group:		Applications/System
Requires:	libuuid >= 2.23

%description support
Virtual Data Optimizer (VDO) is a device mapper target that delivers
block-level deduplication, compression, and thin provisioning.

This package provides the user-space support tools for VDO.

%description support -l pl.UTF-8
Virtual Data Optimizer (VDO) to cel device mappera zapewniający
deduplikację, kompresję i "thin provisioning" na poziomie bloków.

Ten pakiet zawiera narzędzia wspomagające przestrzeni użytkownika dla
VDO.

%prep
%setup -q
%patch -P 0 -p1
%patch -P 1 -p1

%{__sed} -i -e "s,'/usr/libexec','%{_libexecdir}'," vdo-manager/vdomgmnt/Defaults.py

%build
%{__make} \
	CC="%{__cc}" \
	OPT_FLAGS="%{rpmcflags} -fno-omit-frame-pointer"

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	INSTALLOWNER= \
	UDEVDIR=$RPM_BUILD_ROOT/lib/udev/rules.d \
	bindir=%{_bindir} \
	defaultdocdir=%{_docdir} \
	libexecdir=%{_libexecdir} \
	python3_sitelib=%{py3_sitescriptdir} \
	mandir=%{_mandir} \
	unitdir=%{systemdunitdir} \
	sysconfdir=%{_sysconfdir}

%py3_comp $RPM_BUILD_ROOT%{py3_sitescriptdir}
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitescriptdir}

# packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%systemd_post vdo.service

%preun
%systemd_preun vdo.service

%postun
%systemd_postun_with_restart vdo.service

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS.txt README.md examples/{ansible,monitor}
%attr(755,root,root) %{_bindir}/vdo
%attr(755,root,root) %{_bindir}/vdo-by-dev
%attr(755,root,root) %{_bindir}/vdostats
%attr(755,root,root) %{_bindir}/vdodmeventd
%attr(755,root,root) %{_bindir}/vdodumpconfig
%attr(755,root,root) %{_bindir}/vdoforcerebuild
%attr(755,root,root) %{_bindir}/vdoformat
%attr(755,root,root) %{_bindir}/vdosetuuid
%attr(755,root,root) %{_libexecdir}/vdoprepareforlvm
%{py3_sitescriptdir}/%{name}
%{systemdunitdir}/vdo.service
%{systemdunitdir}/vdo-start-by-dev@.service
/lib/systemd/system-preset/97-vdo.preset
/lib/udev/rules.d/69-vdo-start-by-dev.rules
%{_mandir}/man8/vdo.8*
%{_mandir}/man8/vdostats.8*
%{_mandir}/man8/vdodmeventd.8*
%{_mandir}/man8/vdodumpconfig.8*
%{_mandir}/man8/vdoforcerebuild.8*
%{_mandir}/man8/vdoformat.8*
%{_mandir}/man8/vdoprepareforlvm.8*
%{_mandir}/man8/vdosetuuid.8*

%files -n bash-completion-vdo
%defattr(644,root,root,755)
/etc/bash_completion.d/vdo
/etc/bash_completion.d/vdostats

%files support
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/adaptLVMVDO.sh
%attr(755,root,root) %{_bindir}/vdoaudit
%attr(755,root,root) %{_bindir}/vdodebugmetadata
%attr(755,root,root) %{_bindir}/vdodumpblockmap
%attr(755,root,root) %{_bindir}/vdodumpmetadata
%attr(755,root,root) %{_bindir}/vdolistmetadata
%attr(755,root,root) %{_bindir}/vdoreadonly
%attr(755,root,root) %{_bindir}/vdoregenerategeometry
%{_mandir}/man8/adaptlvm.8*
%{_mandir}/man8/vdoaudit.8*
%{_mandir}/man8/vdodebugmetadata.8*
%{_mandir}/man8/vdodumpblockmap.8*
%{_mandir}/man8/vdodumpmetadata.8*
%{_mandir}/man8/vdolistmetadata.8*
%{_mandir}/man8/vdoreadonly.8*
%{_mandir}/man8/vdoregenerategeometry.8*
%changelog
* Sat Mar 22 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/vdo.git;a=log;h=master

* Thu Mar 20 2025 Jan Palus <atler@pld-linux.org> 2373bb8
- up to 6.2.11.5

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 0dca018
- Release 3 (by relup.sh)

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 874bf96
- use patch -P

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 9692a54
- python 3.13 rebuild

* Thu Jun 29 2023 Jakub Bogusz <qboosh@pld-linux.org> 2bd1b60
- more fixes in types patch

* Wed Jun 28 2023 Jan Palus <atler@pld-linux.org> 0f527ca
- up to 6.2.9.7

* Wed Jun 28 2023 Jan Palus <atler@pld-linux.org> 0504766
- BR: python3-modules for %py3_*comp

* Wed Jun 28 2023 Jan Palus <atler@pld-linux.org> 1f50a82
- noarch bash completion

* Wed May 11 2022 Jakub Bogusz <qboosh@pld-linux.org> a82f048
- note on 8.x line

* Mon May 09 2022 Jakub Bogusz <qboosh@pld-linux.org> 9920f30
- updated to 6.2.6.14
- updated types patch

* Mon May 09 2022 Jakub Bogusz <qboosh@pld-linux.org> cdf913a
- updated to 6.2.3.114
- package udev rules in /lib

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 30fa9a6
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 86e6457
- rebuild with python 3.10

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 46e1460
- rebuild with separate debuginfo build-ids

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> 99a1fe4
- release 2 (by relup.sh)

* Tue Jun 02 2020 Jakub Bogusz <qboosh@pld-linux.org> 405f2dc
- initial; with patches to allow build on 32-bit x86

